        IDEAL
        %TITLE "STRT.ASM  pour STRTOOLS.PAS"
        P8086
        PNO87
        MODEL TPASCAL

        DATASEG

        CODESEG


FALSE   = 0
TRUE    = 1



PROC    StrConc    FAR   @@dest:DWORD, @@sour:DWORD

        PUBLIC StrConc
        ;
        ; procedure StrConc( var dest, sour : string );
        ;
        push ds

        cld

        lds  si, [@@sour]
        lodsb               ; charge longueur de sour
        xor  ah, ah         ; la mettre dans AX
        mov  cx, ax         ; la mettre dans CX (mais reste en AX)
        jcxz @@FIN          ; rien  faire

        les  di, [@@dest]
        mov  dl, [es:di]    ; charge la longueur de dest
        xor  dh, dh         ; la mettre dans DX
        add  di, dx
        inc  di             ; se place sur la fin de dest

        rep  movsb          ; copie ...

        mov  di, [WORD LOW @@dest] ; charge seulement l'offset, ES etant bon
        add  al, dl
        mov  [es:di], al    ; nouvelle longueur

@@FIN:
        pop  ds
        ret

ENDP    StrConc



PROC    StrPointer  FAR   @@dest:DWORD, @@pointer:DWORD

        PUBLIC StrPointer
        ;
        ; procedure StrPointer( var dest : string; p : pointer );
        ;
        cld

        les  di, [@@dest]
        mov  al, [es:di]       ; charge la longueur de dest
        xor  ah, ah            ; la mettre dans AX
        add  [BYTE es:di], 9   ; car "0000:0000" a une longueur fixe de 9
        add  di, ax
        inc  di                ; se place sur la fin de dest

        mov  cl, 4
        mov  bx, [WORD HIGH @@pointer]
        mov  al, bh
        shr  al, cl            ; decal les 4 bits suprieur
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bh
        and  al, 15            ; les 4 bits infrieurs
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bl
        shr  al, cl            ; decal les 4 bits suprieur
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bl
        and  al, 15            ; les 4 bits infrieurs
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, ':'
        stosb
        mov  bx, [WORD LOW @@pointer]
        mov  al, bh
        shr  al, cl            ; decal les 4 bits suprieur
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bh
        and  al, 15            ; les 4 bits infrieurs
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bl
        shr  al, cl            ; decal les 4 bits suprieur
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bl
        and  al, 15            ; les 4 bits infrieurs
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb

        ret

ENDP    StrPointer


PROC    StrHexByte  FAR   @@dest:DWORD, @@x:BYTE

        PUBLIC StrHexByte
        ;
        ; procedure StrHexaByte( var s : string; x : byte );
        ;
        cld

        les  di, [@@dest]
        mov  al, [es:di]       ; charge la longueur de dest
        xor  ah, ah            ; la mettre dans AX
        add  [BYTE es:di], 2   ; car "00" a une longueur fixe de 2
        add  di, ax
        inc  di                ; se place sur la fin de dest

        mov  al, [@@x]
        mov  cl, 4
        shr  al, cl            ; decal les 4 bits suprieur
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, [@@x]
        and  al, 15            ; les 4 bits infrieurs
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb

        ret

ENDP    StrHexByte


PROC    StrHexWord  FAR   @@dest:DWORD, @@x:WORD

        PUBLIC StrHexWord
        ;
        ; procedure StrHexaWord( var s : string; x : word );
        ;
        cld

        les  di, [@@dest]
        mov  al, [es:di]       ; charge la longueur de dest
        xor  ah, ah            ; la mettre dans AX
        add  [BYTE es:di], 4   ; car "0000" a une longueur fixe de 4
        add  di, ax
        inc  di                ; se place sur la fin de dest

        mov  cl, 4
        mov  bx, [@@x]
        mov  al, bh
        shr  al, cl            ; decal les 4 bits suprieur
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bh
        and  al, 15            ; les 4 bits infrieurs
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bl
        shr  al, cl            ; decal les 4 bits suprieur
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bl
        and  al, 15            ; les 4 bits infrieurs
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb

        ret

ENDP    StrHexWord


PROC    StrHexLong  FAR   @@dest:DWORD, @@x:DWORD

        PUBLIC StrHexLong
        ;
        ; procedure StrHexaLong( var s : string; x : longint );
        ;
        cld

        les  di, [@@dest]
        mov  al, [es:di]       ; charge la longueur de dest
        xor  ah, ah            ; la mettre dans AX
        add  [BYTE es:di], 8   ; car "00000000" a une longueur fixe de 8
        add  di, ax
        inc  di                ; se place sur la fin de dest

        mov  cl, 4
        mov  bx, [WORD HIGH @@x]
        mov  al, bh
        shr  al, cl            ; decal les 4 bits suprieur
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bh
        and  al, 15            ; les 4 bits infrieurs
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bl
        shr  al, cl            ; decal les 4 bits suprieur
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bl
        and  al, 15            ; les 4 bits infrieurs
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb

        mov  bx, [WORD LOW @@x]
        mov  al, bh
        shr  al, cl            ; decal les 4 bits suprieur
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bh
        and  al, 15            ; les 4 bits infrieurs
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bl
        shr  al, cl            ; decal les 4 bits suprieur
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb
        mov  al, bl
        and  al, 15            ; les 4 bits infrieurs
        add  al, 90h
        daa
        adc  al, 40h
        daa
        stosb

        ret

ENDP    StrHexLong


PROC    StrPlaneLeft  FAR  @@s:DWORD

        PUBLIC StrPlaneLeft
        ;
        ; StrPlaneLeft( var s : string );
        ;
        push ds

        cld

        lds  si, [@@s]
        lodsb               ; charge la longueur de la chaine
        mov  cl, al
        xor  ch, ch         ; la place dans CX
        jcxz @@FIN          ; c'est vide !
@@BOUCLE:
        lodsb
        cmp  al, ' '
        jne  @@ICI
        loop @@BOUCLE       ; boucle tant qu'il y a des espaces;
                            ; (ne pas utiliser loope qui dec(cx) tjrs!)
@@ICI:
        ; CX renvoi aussi la longueur de la future chaine
        les  di, [@@s]
        mov  al, cl
        stosb               ; ecrire la nouvelle longueur
        jcxz @@FIN          ; c'est devenu vide !
        dec  si             ; car il y a eu incrementation avec lodsb
        rep  movsb          ; sinon copier (dplacer) ce qui reste...

@@FIN:
        pop  ds

        ret

ENDP    StrPlaneLeft



PROC    StrPlaneRight  FAR  @@s:DWORD

        PUBLIC StrPlaneRight
        ;
        ; procedure StrPlaneRight( var s : string );
        ;
        push ds

        lds  si, [@@s]
        mov  cl, [si]
        xor  ch, ch
        jcxz @@FIN       ; c'est vide !

        add  si, cx
        std              ; en sens inverse ici
@@BOUCLE:
        lodsb
        cmp  al, ' '
        jne  @@ICI
        loop @@BOUCLE  ; boucle tant qu'il y a des espaces
@@ICI:
        mov  si, [WORD LOW @@s]   ; recharge uniquement l'offset
        mov  [si], cl           ; et hop !

@@FIN:
        pop  ds

        ret

ENDP    StrPlaneRight



PROC    StrDelChar  FAR  @@texte:DWORD, @@c:BYTE

        PUBLIC StrDelChar
        ;
        ; StrDelChar( var texte : string; c : char );
        ;
        push ds

        lds  si, [@@texte]
        cld
        lodsb             ; charge la longueur
        mov  cl, al
        xor  ch, ch       ; la place dans CX
        jcxz @@FIN        ; c'est vide !
        les  di, [@@texte]
        inc  di           ; es:di = ds:si  ce niveau
        mov  ah, [@@c]      ; c'est + mieux
@@BOUCLE:
        lodsb
        cmp  al, ah
        je   @@LA         ; saute
        stosb             ; continue
@@LA:
        loop @@BOUCLE
        mov  ax, si
        sub  ax, di                 ; la difference
        mov  si, [WORD LOW @@texte]   ; recharge uniquement l'offset
        sub  [si], al               ; nouvelle longueur
@@FIN:
        pop  ds

        ret

ENDP    StrDelChar


PROC    _StrChgChar  FAR  @@texte:DWORD, @@pos:WORD, @@lg:WORD, @@CharEx:BYTE, @@CharNew:BYTE

        PUBLIC _StrChgChar
        ;
        ; _StrChgChar( var texte : string; pos : word; lg : integer; CharEx, CharNew : char );
        ;
        mov  cx, [@@lg]
        or   cx, cx
        jle  @@RET        ; si CX<=0

        mov  bx, [@@pos]
        or   bx, bx
        jle  @@RET       ; si BX<=0

        push ds

        lds  si, [@@texte]
        cld
        mov  dl, [si]     ; charge la longueur
        xor  dh, dh
        cmp  bx, dx
        ja   @@FIN        ; pos invalide (pos>longueur chaine)

        mov  ax, cx
        add  ax, bx
        cmp  ax, dx
        jbe  @@ICI
        mov  ax, dx
        sub  ax, bx
        inc  ax
        mov  cx, ax
@@ICI:
        add  si, bx
        mov  ah, [@@CharEx] ; c'est + mieux
@@BOUCLE:
        lodsb
        cmp  al, ah
        jne  @@LA
        mov  al, [@@CharNew]
        mov  [si-1], al
@@LA:
        loop @@BOUCLE
@@FIN:
        pop  ds
@@RET:
        ret

ENDP    _StrChgChar



PROC    StrTrunc  FAR  @@texte:DWORD, @@max:WORD

        PUBLIC StrTrunc
        ;
        ; StrTrunc( var texte : string; max : integer );
        ;
        mov  ax, [@@max]
        or   ax, ax
        jl   @@FIN           ; si <0
        or   ah, ah
        jnz  @@FIN           ; si >255, alors toujours >length(texte)
        les  di, [@@texte]
        cmp  [es:di], al
        jbe  @@FIN           ; ca va
        mov  [es:di], al     ; nouvelle longueur
@@FIN:
        ret

ENDP    StrTrunc



PROC    StrInsert  FAR  @@dest:DWORD, @@sour:DWORD, @@pos:WORD

        PUBLIC StrInsert
        ;
        ; StrInsert( var texte, sour : string; pos : integer );
        ;
        mov  bx, [@@pos]       ; pos -> BX
        or   bx, bx
        jle  @@RET             ; pos <=0 invalide

        push ds

        lds  si, [@@sour]
        mov  dl, [si]
        xor  dh, dh            ; longueur chaine source (nb) -> DX

        lds  si, [@@dest]
        mov  cl, [si]
        xor  ch, ch            ; longueur de la chaine -> CX
        mov  ax, cx
        inc  ax
        cmp  bx, ax
        ja   @@FIN             ; pos invalide ( pos>longueur chaine+1 )

        mov  ax, dx
        add  ax, cx
        mov  [si], al          ; nouvelle longueur de chaine

        jcxz @@LA              ; rien  dcaler ! chaine vide !

        add  si, cx            ; pointer sur le car de fin de chaine
        les  di, [@@dest]
        add  di, ax            ; nouvelle fin de chaine

        sub  cx, bx
        inc  cx                ; longueur  decaler
        jcxz @@LA              ; car BX peut tre =cx+1
        std                    ; on copie en partant de la fin ...
        rep  movsb
@@LA:
        lds  si, [@@sour]
        inc  si
        les  di, [@@dest]
        add  di, bx
        mov  cx, dx
        cld
        rep  movsb
@@FIN:
        pop  ds
@@RET:
        ret

ENDP    StrInsert



PROC    StrInsChar  FAR  @@texte:DWORD, @@pos:WORD, @@nb:WORD, @@c:BYTE

        PUBLIC StrInsChar
        ;
        ; StrInsChar( var texte : string; pos, nb : integer; c : char );
        ;
        mov  dx, [@@nb]        ; nb -> DX
        or   dx, dx
        jle  @@RET             ; si DX<=0, car rien  faire !

        mov  bx, [@@pos]       ; pos -> BX
        or   bx, bx
        jle  @@RET             ; pos <=0 invalide

        push ds

        lds  si, [@@texte]
        mov  cl, [si]
        xor  ch, ch            ; longueur de la chaine -> CX
        mov  ax, cx
        inc  ax
        cmp  bx, ax
        ja   @@FIN             ; pos invalide ( pos>longueur chaine+1 )

        mov  ax, dx
        add  ax, cx
        mov  [si], al          ; nouvelle longueur de chaine

        jcxz @@LA              ; rien  dcaler ! chaine vide !

        add  si, cx            ; pointer sur le car de fin de chaine
        les  di, [@@texte]
        add  di, ax            ; nouvelle fin de chaine

        sub  cx, bx
        inc  cx                ; longueur  decaler
        jcxz @@LA              ; car BX peut tre =cx+1
        std                    ; on copie en partant de la fin ...
        rep  movsb
@@LA:
        ; remplir de "c"
        les  di, [@@texte]
        add  di, bx
        mov  cx, dx            ; forcement non nul
        mov  al, [@@c]
        cld                    ; on incremente ...
        rep  stosb             ; remplir...

@@FIN:
        pop  ds
@@RET:
        ret

ENDP    StrInsChar



PROC    StrDel  FAR  @@texte:DWORD, @@pos:WORD, @@nb:WORD

        PUBLIC StrDel
        ;
        ; StrDel( var texte : string; pos, nb : integer );
        ;
        mov  dx, [@@nb]        ; nb -> DX
        or   dx, dx
        jle  @@RET             ; si DX<=0 , rien  faire !

        mov  bx, [@@pos]
        or   bx, bx
        jle  @@RET             ; si BX<=0 , pos invalide !

        push ds

        lds  si, [@@texte]
        mov  cl, [si]
        xor  ch, ch            ; longueur de la chaine -> CX
        jcxz @@FIN             ; rien  dcaler !
        cmp  bx, cx
        ja   @@FIN             ; pos invalide ( pos>longueur chaine )

        mov  ax, bx
        add  ax, dx
        cmp  ax, cx
        jbe  @@OK
        ; pos+nb > longueur chaine
        ; alors inutile de decaler quoi que ce soit !
        dec  bx
        mov  [si], bl          ; nouvelle longueur de chaine
        jmp  SHORT @@FIN
@@OK:
        mov  ax, cx
        sub  ax, dx
        mov  [si], al          ; nouvelle longueur de chaine
        add  si, bx
        add  si, dx
        les  di, [@@texte]
        add  di, bx

        mov  ax, bx
        add  ax, dx
        sub  cx, ax
        inc  cx
        cld
        rep  movsb
@@FIN:
        pop  ds
@@RET:
        ret

ENDP    StrDel



PROC    StrFill  FAR  @@texte:DWORD, @@pos:WORD, @@nb:WORD, @@c:BYTE

        PUBLIC StrFill
        ;
        ; StrFill( var texte : string; pos, nb : integer; c : char );
        ;
        mov  cx, [@@nb]        ; nb -> CX
        or   cx, cx
        jle  @@RET             ; si CX<=0 rien  faire
@@_01:
        mov  bx, [@@pos]
        or   bx , bx
        jle  @@RET             ; pos<=0 !!

        les  di, [@@texte]
        mov  dl, [es:di]       ; charge la longueur
        xor  dh, dh
        inc  dx                ; longueur chaine + 1
        cmp  bx, dx
        ja   @@RET             ; si pos>longueur chaine+1

        mov  ax, bx
        add  ax, cx
        cmp  ax, dx
        jbe  @@LA
        dec  ax
        mov  [es:di], al       ; nouvelle longueur
@@LA:
        ; remplir
        add  di, bx
        mov  al, [@@c]
        cld
        rep  stosb
@@RET:
        ret

ENDP    StrFill


TabInt  DW   0CA00h, 03B9Ah, 0E100h, 005F5h, 09680h
        DW   00098h, 04240h, 0000Fh, 086A0h, 00001h
        DW   02710h, 00000h, 003E8h, 00000h, 00064h
        DW   00000h, 0000Ah, 00000h, 00001h, 00000h


PROC    StrInt    FAR   @@dest:DWORD, @@x:DWORD

        PUBLIC StrInt
        ;
        ; procedure StrInt( var dest : string; x : longint );
        ;

        mov  bx, [WORD LOW @@x]
        mov  dx, [WORD HIGH @@x]
        xor  ch, ch          ; 0=>sign positif

        or   dx, dx
        jnl  @@_0272
        not  bx
        not  dx
        add  bx, 00001h
        adc  dx, 00000h
        mov  ch, 1           ; ngatif!
@@_0272:
        mov  si, OFFSET TabInt
        mov  cl, 009h
@@_0277:
        cmp  dx, [cs:si+002h]
        jb   @@_0284
        ja   @@_028B
        cmp  bx, [cs:si]
        jnb  @@_028B
@@_0284:
        add  si, 00004h
        dec  cl
        jne  @@_0277
@@_028B:
        inc  cl

        cld
        les  di, [@@dest]
        mov  al, [es:di]     ; longueur de la chaine actuellement (garde)
        mov  ah, cl
        or   ch, ch
        jz   @@_LA
        inc  ah
@@_LA:
        add  [es:di], ah     ; nouvelle longueur dans tous les cas

        xor  ah, ah
        inc  ax              ; +1
        add  di, ax          ; [es:di] sur la fin de chaine+1

        or   ch, ch
        jz   @@_ICI
        mov  al, '-'         ; nombre negatif, ecrire le signe...
        stosb
@@_ICI:
@@_028D:
        mov  al, '/'
@@_028F:
        inc  al
        sub  bx, [cs:si]
        sbb  dx, [cs:si+002h]
        jnb  @@_028F
        add  bx, [cs:si]
        adc  dx, [cs:si+002h]
        add  si, 00004h
        stosb
        dec  cl
        jne  @@_028D

        ret

ENDP    StrInt


PROC    Str_Int   FAR   @@dest:DWORD, @@x:DWORD, @@surf:WORD

        PUBLIC Str_Int
        ;
        ; procedure Str_Int( var dest : string; x : longint; surf : integer );
        ;

        mov  bx, [WORD LOW @@x]
        mov  dx, [WORD HIGH @@x]
        xor  ch, ch          ; 0=>sign positif

        or   dx, dx
        jnl  @@_0272
        not  bx
        not  dx
        add  bx, 00001h
        adc  dx, 00000h
        mov  ch, 1           ; ngatif!
@@_0272:
        mov  si, OFFSET TabInt
        mov  cl, 009h
@@_0277:
        cmp  dx, [cs:si+002h]
        jb   @@_0284
        ja   @@_028B
        cmp  bx, [cs:si]
        jnb  @@_028B
@@_0284:
        add  si, 00004h
        dec  cl
        jne  @@_0277
@@_028B:
        inc  cl

        push cx              ; sauve CX

        cld
        les  di, [@@dest]

        mov  al, cl          ; longueur du nombre
        or   ch, ch
        jz   @@_XX
        inc  al              ; car signe "-" en plus !
@@_XX:
        xor  ah, ah
        mov  cx, [@@surf]
        or   cx, cx
        jle  @@_IGNORE       ; si <=0
        cmp  ax, cx
        jae  @@_IGNORE       ; rien  remplir ! (dumoins insignifiant)

        push [es:di]         ; longueur chaine actuelle (sauve)
        add  [es:di], cl     ; longueur nouvelle
        sub  cx, ax          ; la taille  remplir (forcement >0)
        pop  ax
        xor  ah, ah          ; AX=ex longueur de chaine
        inc  ax
        add  di, ax          ; [es:di] pointe sur la fin de la chaine+1

        mov  al, ' '
        rep  stosb           ; remplir d'espace
                             ; [es:di] sont bon pour la suite...
        jmp  SHORT @@_CONT
@@_IGNORE:
        ; ici, AX=longueur  ecrire
        mov  ah, [es:di]     ; longueur actuelle
        add  [es:di], al     ; nouvelle longueur de la chaine
        xchg al, ah
        xor  ah, ah
        inc  ax              ; +1
        add  di, ax          ; [es:di] sur la fin de chaine+1
@@_CONT:
        pop  cx              ; restore
        ;
        ;  ce niveau, [es:di] est bon, la longueur de la chaine est fix
        ;
        or   ch, ch
        jz   @@_ICI
        mov  al, '-'         ; nombre negatif, ecrire le signe...
        stosb
@@_ICI:
@@_028D:
        mov  al, '/'
@@_028F:
        inc  al
        sub  bx, [cs:si]
        sbb  dx, [cs:si+002h]
        jnb  @@_028F
        add  bx, [cs:si]
        adc  dx, [cs:si+002h]
        add  si, 00004h
        stosb
        dec  cl
        jne  @@_028D

        ret

ENDP    Str_Int



PROC    _ValBin  FAR  @@s:DWORD, @@deb:WORD, @@result:DWORD

        PUBLIC _ValBin
        ;
        ; function _ValBin( var s : string; deb : word;
        ;                   var result : longint ) : boolean;
        ;
        mov  bx, [@@deb]
        or   bx, bx
        jnle @@_01          ; si BX>0 (donc valide)
                            ; si BX<=0 , pos invalide !
                            ; sort avec FALSE
        xor  al, al
        jmp  SHORT @@RET
@@_01:
        push ds
        lds  si, [@@s]
        mov  al, [si]
        xor  ah, ah         ; longueur de la chaine dans AX
        cmp  ax, bx
        jae  @@_02          ; si AX>=BX
                            ; bx (deb) trop grand !
@@FALSE:
        xor  al , al
        jmp  SHORT @@FIN    ; sort avec FALSE
@@_02:
        mov  cx, ax
        sub  cx, bx
        inc  cx             ; longueur  lire pour analyse... (tjrs non nul)
        add  si, bx         ; ds:si pointe sur le debut  lire
        xor  bx, bx
        xor  dx, dx         ; dx:bx = entier long en cours d'etude
        cld
@@BOUCLE:
        lodsb               ; lit le car
        sub  al, '0'        ; -'0'
        cmp  al, 1
        ja   @@FALSE        ; erreur de syntaxe! '0' ou '1' seulement !
        cmc                 ; car, si al=1 => cf=0, si al<1 => cf=1 !!
        rcl  bx, 1          ; rotate with carry
        rcl  dx, 1
        jc   @@FALSE        ; depassement de capacit 16 bits !
        loop @@BOUCLE

        lds  si, [@@result]
        mov  [si], bx
        mov  [si+2], dx  ; ecrit le resultat
        mov  al, TRUE            ; sort avec TRUE
@@FIN:
        pop  ds
@@RET:
        ret

ENDP    _ValBin


PROC    _ValHex  FAR  @@s:DWORD, @@deb:WORD, @@result:DWORD

        PUBLIC _ValHex
        ;
        ; function _ValHex( var s : string; deb : word;
        ;                    var result : longint ) : boolean;
        ;
        mov  bx, [@@deb]
        or   bx, bx
        jnle @@_01          ; si BX>0 (donc valide)
                            ; si BX<=0 , pos invalide !
                            ; sort avec FALSE
        xor  al, al
        jmp  SHORT @@RET
@@_01:
        push ds
        lds  si, [@@s]
        mov  al, [si]
        xor  ah, ah         ; longueur de la chaine dans AX
        cmp  ax, bx
        jae  @@_02          ; si AX>=BX
                            ; bx (deb) trop grand !
@@FALSE:
        xor  al , al
        jmp  SHORT @@FIN    ; sort avec FALSE
@@_02:
        mov  cx, ax
        sub  cx, bx
        inc  cx             ; longueur  lire pour analyse... (tjrs non nul)
        add  si, bx         ; ds:si pointe sur le debut  lire
        xor  bx, bx
        xor  dx, dx         ; dx:bx = entier long en cours d'etude
        cld
@@BOUCLE:
        lodsb               ; lit le car
        cmp  al, 'a'
        jb   @@_03
        cmp  al, 'f'
        ja   @@FALSE        ; car incorrecte
        sub  al, 32         ; -32!  UpCase(al)
        jmp  SHORT @@_05
@@_03:
        cmp  al, '0'
        jb   @@FALSE
        cmp  al, '9'
        ja   @@_04
        ;
        ; 0..9
        ;
        sub  al, '0'
        jmp  SHORT @@CONT
@@_04:
        cmp  al, 'A'
        jb   @@FALSE
        cmp  al, 'F'
        ja   @@FALSE
        ;
        ; A..F
        ;
@@_05:
        sub  al, 'A'-10
@@CONT:
        test dx, 0F000h
        jnz  @@FALSE        ; depassement de capacit
        push cx             ; sauve cx
        mov  cl, 4
        shl  dx, cl         ; dx*16  dx= xxxx xxxx xxxx 0000
        mov  ah, bh         ;        ah= ???? xxxx
        shr  ah, cl         ;        ah= 0000 ????
        or   dl, ah         ;        dx= xxxx xxxx xxxx ????
        shl  bx, cl
        or   bl, al
        pop  cx             ; restore cx
        loop @@BOUCLE

        lds  si, [@@result]
        mov  [si], bx
        mov  [si+2], dx  ; ecrit le resultat
        mov  al, TRUE            ; sort avec TRUE
@@FIN:
        pop  ds
@@RET:
        ret

ENDP    _ValHex



PROC    StrPosChar  FAR  @@s:DWORD, @@pos:WORD, @@c:BYTE

        PUBLIC StrPosChar
        ;
        ; function StrPosChar( var s : string; pos : integer; c : char ) : word;
        ;
        mov  bx, [@@pos]
        or   bx, bx
        jnle @@LA
        xor  ax, ax          ; renvoi 0
        jmp  SHORT @@RET
@@LA:
        push ds

        lds  si, [@@s]
        cld
        mov  cl, [si]        ; longueur chaine
        xor  ch, ch
        cmp  bx, cx
        jbe  @@ICI
        ; bx trop grand !
        xor  ax, ax          ; renvoi 0
        jmp  SHORT @@FIN
@@ICI:
        sub  cx, bx
        inc  cx
        add  si, bx
        mov  ah, [@@c]
@@BOUCLE:
        lodsb
        cmp  al, ah
        loopne @@BOUCLE
        je   @@OK
        ; non egal
        xor  ax, ax          ; renvoi 0
        jmp  SHORT @@FIN
@@OK:
        mov  ax, si
        mov  si, [WORD LOW @@s]
        sub  ax, si
        dec  ax              ; renvoi pos<>0
@@FIN:
        pop  ds
@@RET:
        ret

ENDP    StrPosChar



PROC    StrUpCase  FAR   @@Txt:DWORD   ; UpCaseStr(pointeur)

        PUBLIC StrUpCase
        ;
        ; procedure StrUpCase( var Txt : string );
        ;
        push ds

        cld

        lds  si, [@@Txt]             ; pointeur sur texte
        lodsb                         ; prend la longueur texte
        mov  cl, al                ; lg->cl
        xor  ch,ch
        jcxz @@FIN                 ; rien a faire cx=0
        mov  ax, ds
        mov  es, ax
        mov  di, si                ; es:di = ds:si
@@BOUCLE:
        lodsb
        cmp  al, 'a'
        jb   @@LA
        cmp  al, 'z'
        ja   @@LA
        sub  al, 32                ; -32!
@@LA:
        stosb
        loop @@BOUCLE
@@FIN:
        pop  ds
        ret

ENDP    StrUpCase




PROC    MemComp  FAR  @@x1:DWORD, @@x2:DWORD, @@lg:WORD

        PUBLIC MemComp
        ;
        ; function MemSame( var x1,x2; lg : word ) : integer;
        ;
        push    ds

        mov  cx, [@@Lg]
        jcxz @@YES
        lds  si, [@@x1]
        les  di, [@@x2]
        cld
        repe cmpsb
        je   @@YES
        ja   @@SUP
        mov  ax, -1
        jmp  SHORT @@Fin
@@SUP:
        mov  ax, +1
        jmp  SHORT @@Fin
@@YES:
        mov  ax, 0                ; egal!
@@Fin:
        pop  ds
        ret

ENDP    MemComp




PROC    StrComp FAR  @@Refer:DWORD, @@Sujet:DWORD, @@MinMaj:BYTE

        PUBLIC StrComp
        ;
        ; function StrComp( var Refer, Sujet : string; MinMaj : boolean ) : integer;
        ;

        push ds

        lds  si, [@@Refer]
        les  di, [@@Sujet]
        mov  cl, [ds:si]        ; cl=length(Refer)
        mov  ch, [es:di]        ; ch=length(Sujet)
        inc  si
        inc  di

        cld
        or   cl, cl
        jz   @@FINBOUCLE
@@BOUCLE:
        lodsb
        or   al, al
        jz   @@EGAL             ; fin trouv 0
        or   ch, ch
        jz   @@SUP              ; fin +1
        cmp  al, 1
        je   @@NEXT
        mov  ah, [es:di]
        cmp  [@@MinMaj], 0
        jne  @@ICI_02           ; Branch si on respecte les Min/Maj
        cmp  al, 'a'
        jb   @@ICI_01
        cmp  al, 'z'
        ja   @@ICI_01
        sub  al, 32             ; -32!
@@ICI_01:
        cmp  ah, 'a'
        jb   @@ICI_02
        cmp  ah, 'z'
        ja   @@ICI_02
        sub  ah, 32             ; -32!
@@ICI_02:
        cmp  al, ah
        ja   @@SUP
        jb   @@INF
@@NEXT:
        inc  di
        dec  ch
        dec  cl
        jnz  @@BOUCLE
@@FINBOUCLE:
        cmp  ch, cl
        ja   @@INF
@@EGAL:
        mov  ax, 0              ; Egal!
        jmp  SHORT @@FIN
@@INF:
        mov  ax, -1             ; inferieur!
        jmp  SHORT @@FIN
@@SUP:
        mov  ax, +1             ; superieur
@@FIN:
        pop  ds
        ret

ENDP    StrComp



        ; tableau de normalisation ... de 128  173
TabNorm DB  'C','u','e','a','a','a','a','c','e','e','e','i','i','i','A','A'
        DB  'E','','','o','o','o','u','u','y','O','U','','','','',''
        DB  'a','i','o','u','n','N','a','o','','','','','','i'


PROC    StrNorm   FAR    @@sour:DWORD

        PUBLIC StrNorm
        ;
        ; procedure StrNorm( var sour : string );
        ; (normalise une chaine: en fait, vire les accents)
        ;
        push ds

        cld

        lds  si, [@@sour]
        lodsb                    ; charge la longueur
        mov  cl, al
        xor  ch, ch
        jcxz @@FIN
        mov  ax, ds
        mov  es, ax
        mov  di, si
@@BOUCLE:
        lodsb
        cmp  al, 128
        jb   @@RAP
        cmp  al, 173
        ja   @@RAP
        mov  bl, al
        xor  bh, bh
        sub  bx, 128
        mov  al, [cs:OFFSET TabNorm+bx]
        stosb
        loop @@BOUCLE
        jmp  SHORT @@FIN
@@RAP:
        inc  di
        loop @@BOUCLE
@@FIN:
        pop  ds
        ret

ENDP    StrNorm



        END
