        IDEAL
        %TITLE "STRVDT.ASM  pour STRTOOLS.PAS"
        P8086
        PNO87
        MODEL TPASCAL

        DATASEG

        CODESEG


FALSE   = 0
TRUE    = 1



;
; Tableau de conversions des caractres superieur  128
; tableau de 128*2 lments
;

TabSup128  DB   75,'C', 72,'u', 66,'e', 67,'a', 72,'a', 65,'a' ; 128..""
           DB   0,0,    75,'c', 67,'e', 72,'e', 65,'e', 72,'i' ; 134..""
           DB   67,'i', 0,'i',  0,'A',  67,'A', 66,'E', 'z',0  ; 140..""
           DB   'j',0,  67,'o', 72,'o', 0,'o',  67,'u', 65,'u' ; 146..""
           DB   0,'y',  0,'O',  0,'U',  0,0,    '#',0,  0,0    ; 152..""
           DB   0,0,    0,0,    0,'a',  0,'i',  0,'o',  0,'u'  ; 158..""
           DB   0,'n',  0,'N',  0,0,    0,0,    0,0,    0,0    ; 164..""
           DB   0,0,    '=',0,  '<',0,  0,0,    0,0,    0,0    ; 170..""
           DB   0,127,  0,127,  0,127,  0,'|',  46,0,   0,0    ; 176..""
           DB   0,0,    0,0,    0,0,    0,0,    0,'|',  0,0    ; 182..""
           DB   0,0,    0,0,    0,0,    0,0,    0,0,    47,0   ; 188..""
           DB   45,0,   44,0,   0,'`',  0,0,    0,0,    0,0    ; 194..""
           DB   0,0,    0,0,    0,0,    0,0,    0,0,    0,'`'  ; 200..""
           DB   0,0,    0,0,    0,0,    0,0,    0,0,    0,0    ; 206..""
           DB   0,0,    0,0,    0,0,    0,0,    0,0,    0,0    ; 212..""
           DB   0,0,    0,127,  0,'_',  0,'{',  0,'}',  0,'~'  ; 218..""
           DB   0,0,    '{',0,  0,0,    0,0,    0,0,    0,0    ; 224..""
           DB   0,0,    0,0,    39,0,   0,0,    0,0,    0,0    ; 230..""
           DB   0,0,    '>',0,  0,0,    0,0,    0,0,    '1',0  ; 236..""
           DB   0,0,    0,0,    0,0,    0,0,    56,0,   0,0    ; 242..""
           DB   '0',0,  0,0,    0,0,    0,0,    0,0,    0,0    ; 248..""
           DB   0,0,    0,0                                    ; 254..255


PROC    IbmVdt    FAR   @@sour:DWORD, @@dest:DWORD

        PUBLIC IbmVdt
        ;
        ; procedure IbmVdt( var sour, dest : string );
        ;
        push ds

        lds  si, [@@sour]
        les  di, [@@dest]
        inc  di               ; premier car  ecrire
        mov  cl, [si]         ; saisie de la longueur de "sour"
        xor  ch, ch           ; -> CX
        jcxz @@FIN            ; rien  convertir
        inc  si
        cld
@@BOUCLE:
        lodsb
        cmp  al, 128
        jae  @@LA             ; si >=128
        stosb
        jmp  SHORT @@CONT
@@LA:
        xor  ah, ah
        sub  ax, 128
        shl  ax, 1
        mov  bx, ax
        mov  dx, [cs:OFFSET TabSup128+bx]
        or   dl, dl
        jz   @@_01            ; dl=0
        mov  al, 25
        stosb
        mov  al, dl
        stosb
@@_01:
        or   dh, dh
        jz   @@_02
        mov  al, dh
        stosb
        jmp  SHORT @@CONT
@@_02:
        or   dl, dl
        jnz  @@CONT
        mov  al, '?'          ; car intraduisible
        stosb
@@CONT:
        loop @@BOUCLE
@@FIN:
        mov  si, [WORD LOW @@dest]   ; recharge l'offset
        mov  ax, di
        sub  ax, si
        dec  ax
        mov  [es:si], al      ; longueur dans dest

        pop  ds
        ret

ENDP    IbmVdt



        ; #25#x -> IBM o x<>65,66,67,72,75
        ;
        ;   TabExt : array[32..127] of char =

TabExt DB  '_','_','_','','$','_','#','','_','_','_','_','','','',''
       DB  '','','_','_','_','_','_','_','','_','_','_','','','','_'
       DB  '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_'
       DB  '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_'
       DB  '_','_','_','_','_','_','_','_','_','_','','_','_','_','_','_'
       DB  '_','_','_','_','_','_','_','_','_','_','','','_','_','_','_'

TabAccent_A  DB  '','a','','a','a','a','a',''  ;  [65..72] of char ...
TabAccent_E  DB  '','','','e','e','e','e',''
TabAccent_I  DB  'i','i','','i','i','i','i',''
TabAccent_O  DB  'o','o','','o','o','o','o',''
TabAccent_U  DB  '','u','','u','u','u','u',''


PROC    VdtIbm    FAR   @@sour:DWORD, @@dest:DWORD

        PUBLIC VdtIbm
        ;
        ; procedure VdtIbm( var sour, dest : string );
        ;
        ; ah= aiguillage interne: 0=>rien  1=>25x  2=>25xy
        push ds

        lds  si, [@@sour]
        les  di, [@@dest]
        inc  di               ; premier car  ecrire
        mov  cl, [si]         ; saisie de la longueur de "sour"
        xor  ch, ch           ; -> CX
        or   cx, cx
        jnz  @@ICI
        jmp  @@FIN            ; rien  convertir
@@ICI:
        inc  si
        cld
        xor  ah, ah           ; Aig=0
@@BOUCLE:
        lodsb
        cmp  al, ' '
        jae  @@_03
        cmp  al, 25
        je   @@_01
        cmp  al, 22
        jne  @@_02
@@_01:
        mov  ah, 1            ; aig=1 => 25x (attendu)
        jmp  @@CONT
@@_02:  xor  ah, ah           ; aig=0
        jmp  @@CONT           ; ignore
@@_03:
        cmp  al, 128
        jae  @@CONT           ; ignore si >=128
        or   ah, ah
        jnz  @@_03bis         ; aig<>0
        ; Aig=0, donc ecrit al directement
        stosb
        jmp  SHORT @@CONT
@@_03bis:
        cmp  ah, 1
        jne  @@_06
        cmp  al, 65
        jb   @@_05            ; si al<65
        cmp  al, 67
        jbe  @@_04            ; si al<=67 (ok!)
        cmp  al, 72
        je   @@_04            ; si al=72 (ok!)
        cmp  al, 75
        jne  @@_05            ; si al<>75
@@_04:
        mov  dl, al           ; sauve al dans dl (Ext)
        mov  ah, 2            ; Aig=2
        jmp  SHORT @@CONT
@@_05:
        mov  bl, al
        xor  bh, bh
        sub  bx, 32
        mov  al, [cs:OFFSET TabExt+bx]
        jmp  SHORT @@ECRIT
@@_06:
        ; Aig=2 (forcement)
        cmp  dl, 75           ; (dl= ex al)
        jne  @@_08
        cmp  al, 'c'
        jne  @@_07
        mov  al, ''
        jmp  SHORT @@ECRIT
@@_07:
        cmp  al, 'C'
        jne  @@ECRIT          ; ne converti pas al
        mov  al, ''
        jmp  SHORT @@ECRIT
@@_08:
        cmp  al, 'a'
        jne  @@_09
        mov  bx, OFFSET TabAccent_A
        jmp  SHORT @@_13
@@_09:
        cmp  al, 'e'
        jne  @@_10
        mov  bx, OFFSET TabAccent_E
        jmp  SHORT @@_13
@@_10:
        cmp  al, 'i'
        jne  @@_11
        mov  bx, OFFSET TabAccent_I
        jmp  SHORT @@_13
@@_11:
        cmp  al, 'o'
        jne  @@_12
        mov  bx, OFFSET TabAccent_O
        jmp  SHORT @@_13
@@_12:
        cmp  al, 'u'
        jne  @@ECRIT          ; ne converti pas !
        mov  bx, OFFSET TabAccent_U
@@_13:
        mov  al, dl
        xor  ah, ah
        sub  ax, 65
        add  bx, ax
        mov  al, [cs:bx]
@@ECRIT:
        stosb
        xor  ah, ah           ; aig=0
@@CONT:
        dec  cx
        jz   @@FIN
        jmp  @@BOUCLE         ; simul LOOP @@BOUCLE
@@FIN:
        mov  si, [WORD LOW @@dest]   ; recharge l'offset
        mov  ax, di
        sub  ax, si
        dec  ax
        mov  [es:si], al      ; longueur dans dest

        pop  ds
        ret

ENDP    VdtIbm


PROC    DelCtrlChar   FAR   @@s:DWORD

@@NUL   = 0       ; diffrent tat de l'aiguillage (AH)
@@IGN_1 = 1       ; ignore le prochain code
@@IGN_2 = 2       ; ignore les 2 prochains
@@IGN_3 = 3       ; les 3 ...
@@ESC   = 4

        PUBLIC DelCtrlChar
        ;
        ; procedure DelCtrlChar( var s : string );
        ;
        push ds

        lds  si, [@@s]
        les  di, [@@s]
        inc  di               ; premier car  ecrire
        mov  cl, [si]         ; saisie de la longueur de "s"
        xor  ch, ch           ; -> CX
        jcxz @@FIN            ; rien  convertir
        inc  si
        cld
        xor  ah, ah           ; aig=NUL
@@BOUCLE:
        lodsb
        or   ah, ah
        jnz  @@_06            ; si aig<>NUL
        ; aig=NUL
        cmp  al, ' '
        jae  @@_05            ; si al>=' '
        cmp  al, 19
        jne  @@_01            ; si al<>19
        mov  ah, @@IGN_1      ; ignore le prochain code
        jmp  SHORT @@CONT
@@_01:
        cmp  al, 22
        je   @@_02
        cmp  al, 25
        jne  @@_03
@@_02:
        stosb                 ; garde #25... ou #22...
        jmp  SHORT @@CONT
@@_03:
        cmp  al, 27
        jne  @@_04
        mov  ah, @@ESC
        jmp  SHORT @@CONT
@@_04:
        cmp  al, 31
        jne  @@CONT           ; si <>31, ignore
        mov  ah, @@IGN_2      ; ignore les 2 prochains codes
        jmp  SHORT @@CONT
@@_05:
        cmp  al, 128
        jae  @@CONT           ; si al>=128, ignore
        stosb
        jmp  SHORT @@CONT
@@_06:
        cmp  ah, @@ESC
        jne  @@_11
        cmp  al, 039h
        jne  @@_08
        mov  ah, @@IGN_1
        jmp  SHORT @@CONT
@@_08:
        cmp  al, 03Ah
        jne  @@_09
        mov  ah, @@IGN_2
        jmp  SHORT @@CONT
@@_09:
        cmp  al, 03Bh
        jne  @@AIGNUL         ; si al<>$3B
        mov  ah, @@IGN_3
        jmp  SHORT @@CONT
@@_11:
        cmp  ah, @@IGN_1
        je   @@AIGNUL         ; si ah=@@IGN_1
        cmp  ah, @@IGN_2
        jne  @@_13
        mov  ah, @@IGN_1
        jmp  SHORT @@CONT
@@_13:
        cmp  ah, @@IGN_3
        jne  @@AIGNUL
        mov  ah, @@IGN_2
        jmp  SHORT @@CONT
@@AIGNUL:
        xor  ah, ah           ; aig=nul
@@CONT:
        loop @@BOUCLE
@@FIN:
        mov  si, [WORD LOW @@s]   ; recharge l'offset
        mov  ax, di
        sub  ax, si
        dec  ax
        mov  [si], al             ; longueur dans "s"

        pop  ds
        ret

ENDP    DelCtrlChar


        END
